# This file was generated by running 'miaxml2nipype.py /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/doc/mia-2dgroundtruthreg.xml /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_2dgroundtruthreg.py'
# '/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_2dgroundtruthreg.py' can be created by running 'mia-2dgroundtruthreg --help-xml >/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_2dgroundtruthreg.py'

from nipype.interfaces.base import (
        TraitedSpec,
        CommandLineInputSpec,
        CommandLine,
        File,
        traits
    )
import os
#
# Input specification
#
class mia_2dgroundtruthreg_InputSpec(CommandLineInputSpec):
	in_file = traits.File( desc="""input perfusion data set""", argstr="--in-file %s", exists=True , mandatory = True )
	registered = traits.String( desc="""file name base for registered files""", argstr="--registered %s" )
	skip = traits.Int( desc="""skip images at beginning of series""", argstr="--skip %d" )
	passes = traits.Int( desc="""number of registration passes""", argstr="--passes %d" )
	alpha = traits.Float( desc="""spacial neighborhood penalty weight""", argstr="--alpha %f" , mandatory = True )
	beta = traits.Float( desc="""temporal second derivative penalty weight""", argstr="--beta %f" , mandatory = True )
	rho_thresh = traits.Float( desc="""correlation threshold for neighborhood analysis""", argstr="--rho_thresh %f" , mandatory = True )
	optimizer = traits.String( desc="""Optimizer used for minimization""", argstr="--optimizer %s" )
	interpolator = traits.String( desc="""image interpolator kernel""", argstr="--interpolator %s" )
	mr_levels = traits.Int( desc="""multi-resolution levels""", argstr="--mr-levels %d" )
	divcurl = traits.Float( desc="""divcurl regularization weight""", argstr="--divcurl %f" )
	divcurl_divider = traits.Float( desc="""divcurl weight scaling with each new pass""", argstr="--divcurl-divider %f" )
	start_c_rate = traits.Int( desc="""start coefficinet rate in spines, gets divided by --c-rate-divider with every pass""", argstr="--start-c-rate %d" )
	c_rate_divider = traits.Float( desc="""cofficient rate divider for each pass""", argstr="--c-rate-divider %f" )
	imageweight = traits.Float( desc="""image cost weight""", argstr="--imageweight %f" )
	verbose = traits.Enum("info", "trace", "fail", "warning", "error", "debug", "message", "fatal",  desc="""verbosity of output, print messages of given level and higher priorities. Supported priorities starting at lowest level are:""", argstr="--verbose %s" )
	threads = traits.Int( desc="""Maxiumum number of threads to use for processing,This number should be lower or equal to the number of logical processor cores in the machine. (-1: automatic estimation).""", argstr="--threads %d" )
	out_file = File(desc="output perfusion data set", argstr="--out-file %s" , mandatory = True )

#
# Output specification
#
class mia_2dgroundtruthreg_OutputSpec(TraitedSpec):
	out_file = File(desc="output perfusion data set", exists = True )


#
# Task class specification
#
class mia_2dgroundtruthreg(CommandLine):
	input_spec = mia_2dgroundtruthreg_InputSpec
	output_spec = mia_2dgroundtruthreg_OutputSpec
	_cmd = "mia-2dgroundtruthreg"

	def _list_outputs(self):
		outputs = self.output_spec().get()
		outputs['out_file']=os.path.abspath(self.inputs.out_file)
		return outputs

#
# Main function used for testing
#
if __name__ == "__main__":
	mia_prog = mia_2dgroundtruthreg()
	print( mia_prog.cmdline)
