# This file was generated by running 'miaxml2nipype.py /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/doc/mia-2dmyoicapgt.xml /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_2dmyoicapgt.py'
# '/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_2dmyoicapgt.py' can be created by running 'mia-2dmyoicapgt --help-xml >/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_2dmyoicapgt.py'

from nipype.interfaces.base import (
        TraitedSpec,
        CommandLineInputSpec,
        CommandLine,
        File,
        traits
    )
import os
#
# Input specification
#
class mia_2dmyoicapgt_InputSpec(CommandLineInputSpec):
	in_file = traits.File( desc="""input perfusion data set""", argstr="--in-file %s", exists=True , mandatory = True )
	alpha = traits.Float( desc="""spacial neighborhood penalty weight""", argstr="--alpha %f" )
	beta = traits.Float( desc="""temporal second derivative penalty weight""", argstr="--beta %f" )
	rho_thresh = traits.Float( desc="""correlation threshold for neighborhood analysis""", argstr="--rho-thresh %f" )
	registered = traits.String( desc="""File name base for the registered images. Image type and numbering scheme are taken from the input images as given in the input data set.""", argstr="--registered %s" )
	verbose = traits.Enum("info", "trace", "fail", "warning", "error", "debug", "message", "fatal",  desc="""verbosity of output, print messages of given level and higher priorities. Supported priorities starting at lowest level are:""", argstr="--verbose %s" )
	fastica = traits.String( desc="""FastICA implementationto be used""", argstr="--fastica %s" )
	components = traits.Int( desc="""ICA components 0 = automatic estimation""", argstr="--components %d" )
	normalize = traits.Bool( desc="""normalized ICs""", argstr="--normalize" )
	no_meanstrip = traits.Bool( desc="""don't strip the mean from the mixing curves""", argstr="--no-meanstrip" )
	segscale = traits.Float( desc="""segment and scale the crop box around the LV (0=no segmentation)""", argstr="--segscale %f" )
	skip = traits.Int( desc="""skip images at the beginning of the series e.g. because as they are of other modalities""", argstr="--skip %d" )
	max_ica_iter = traits.Int( desc="""maximum number of iterations in ICA""", argstr="--max-ica-iter %d" )
	segmethod = traits.Enum("delta-peak", "features", "delta-feature",  desc="""Segmentation method""", argstr="--segmethod %s" )
	min_breathing_frequency = traits.Float( desc="""minimal mean frequency a mixing curve can have to be considered to stem from brething. A healthy rest breating rate is 12 per minute. A negative value disables the test. A value 0.0 forces the series to be identified as acquired with initial breath hold.""", argstr="--min-breathing-frequency %f" )
	threads = traits.Int( desc="""Maxiumum number of threads to use for processing,This number should be lower or equal to the number of logical processor cores in the machine. (-1: automatic estimation).""", argstr="--threads %d" )
	linear_optimizer = traits.String( desc="""Optimizer used for minimization of the linear registration The string value will be used to construct a plug-in.""", argstr="--linear-optimizer %s" )
	linear_transform = traits.String( desc="""linear transform to be used The string value will be used to construct a plug-in.""", argstr="--linear-transform %s" )
	non_linear_optimizer = traits.String( desc="""Optimizer used for minimization in the non-linear registration. The string value will be used to construct a plug-in.""", argstr="--non-linear-optimizer %s" )
	start_c_rate = traits.Float( desc="""start coefficinet rate in spines, gets divided by --c-rate-divider with every pass.""", argstr="--start-c-rate %f" )
	c_rate_divider = traits.Float( desc="""Cofficient rate divider for each pass.""", argstr="--c-rate-divider %f" )
	start_divcurl = traits.Float( desc="""Start divcurl weight, gets divided by --divcurl-divider with every pass.""", argstr="--start-divcurl %f" )
	divcurl_divider = traits.Float( desc="""Divcurl weight scaling with each new pass.""", argstr="--divcurl-divider %f" )
	reference = traits.Int( desc="""Global reference all image should be aligned to. If set to a non-negative value, the images will be aligned to this references, and the cropped output image date will be injected into the original images. Leave at -1 if you don't care. In this case all images with be registered to a mean position of the movement""", argstr="--reference %d" )
	imagecost = traits.String( desc="""image cost, do not specify the src and ref parameters, these will be set by the program. The string value will be used to construct a plug-in.""", argstr="--imagecost %s" )
	mg_levels = traits.Int( desc="""multi-resolution levels""", argstr="--mg-levels %d" )
	linear_passes = traits.Int( desc="""linear registration passes (0 to disable)""", argstr="--linear-passes %d" )
	nonlinear_passes = traits.Int( desc="""non-linear registration passes (0 to disable)""", argstr="--nonlinear-passes %d" )
	out_file = File(desc="output perfusion data set", argstr="--out-file %s" , mandatory = True )
	save_cropped = File(desc="save cropped set to this file, the image files will use the stem of the name as file name base", argstr="--save-cropped %s" )
	save_feature = File(desc="save segmentation feature images and initial ICA mixing matrix", argstr="--save-feature %s" )
	save_refs = File(desc="for each registration pass save the reference images to files with the given name base", argstr="--save-refs %s" )
	save_regs = File(desc="for each registration pass save intermediate registered images", argstr="--save-regs %s" )

#
# Output specification
#
class mia_2dmyoicapgt_OutputSpec(TraitedSpec):
	out_file = File(desc="output perfusion data set", exists = True )
	save_cropped = File(desc="save cropped set to this file, the image files will use the stem of the name as file name base")
	save_feature = File(desc="save segmentation feature images and initial ICA mixing matrix")
	save_refs = File(desc="for each registration pass save the reference images to files with the given name base")
	save_regs = File(desc="for each registration pass save intermediate registered images")


#
# Task class specification
#
class mia_2dmyoicapgt(CommandLine):
	input_spec = mia_2dmyoicapgt_InputSpec
	output_spec = mia_2dmyoicapgt_OutputSpec
	_cmd = "mia-2dmyoicapgt"

	def _list_outputs(self):
		outputs = self.output_spec().get()
		outputs['out_file']=os.path.abspath(self.inputs.out_file)
		outputs['save_cropped']=os.path.abspath(self.inputs.save_cropped)
		outputs['save_feature']=os.path.abspath(self.inputs.save_feature)
		outputs['save_refs']=os.path.abspath(self.inputs.save_refs)
		outputs['save_regs']=os.path.abspath(self.inputs.save_regs)
		return outputs

#
# Main function used for testing
#
if __name__ == "__main__":
	mia_prog = mia_2dmyoicapgt()
	print( mia_prog.cmdline)
