# This file was generated by running 'miaxml2nipype.py /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/doc/mia-2dmyomilles.xml /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_2dmyomilles.py'
# '/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_2dmyomilles.py' can be created by running 'mia-2dmyomilles --help-xml >/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_2dmyomilles.py'

from nipype.interfaces.base import (
        TraitedSpec,
        CommandLineInputSpec,
        CommandLine,
        File,
        traits
    )
import os
#
# Input specification
#
class mia_2dmyomilles_InputSpec(CommandLineInputSpec):
	in_file = traits.File( desc="""input perfusion data set""", argstr="--in-file %s", exists=True , mandatory = True )
	registered = traits.String( desc="""file name base for registered files""", argstr="--registered %s" )
	save_references = traits.String( desc="""save synthetic reference images to this file base""", argstr="--save-references %s" )
	save_cropped = traits.String( desc="""save cropped image set to this file""", argstr="--save-cropped %s" )
	save_feature = traits.String( desc="""save the features images resulting from the ICA and some intermediate images used for the RV-LV segmentation with the given file name base to PNG files. Also save the coefficients of the initial best and the final IC mixing matrix.""", argstr="--save-feature %s" )
	verbose = traits.Enum("info", "trace", "fail", "warning", "error", "debug", "message", "fatal",  desc="""verbosity of output, print messages of given level and higher priorities. Supported priorities starting at lowest level are:""", argstr="--verbose %s" )
	fastica = traits.String( desc="""FastICA implementationto be used""", argstr="--fastica %s" )
	components = traits.Int( desc="""ICA components 0 = automatic estimation""", argstr="--components %d" )
	normalize = traits.Bool( desc="""normalized ICs""", argstr="--normalize" )
	no_meanstrip = traits.Bool( desc="""don't strip the mean from the mixing curves""", argstr="--no-meanstrip" )
	guess = traits.Bool( desc="""use initial guess for myocardial perfusion""", argstr="--guess" )
	segscale = traits.Float( desc="""segment and scale the crop box around the LV (0=no segmentation)""", argstr="--segscale %f" )
	skip = traits.Int( desc="""skip images at the beginning of the series as they are of other modalities""", argstr="--skip %d" )
	max_ica_iter = traits.Int( desc="""maximum number of iterations in ICA""", argstr="--max-ica-iter %d" )
	segmethod = traits.Enum("delta-peak", "features", "delta-feature",  desc="""Segmentation method""", argstr="--segmethod %s" )
	threads = traits.Int( desc="""Maxiumum number of threads to use for processing,This number should be lower or equal to the number of logical processor cores in the machine. (-1: automatic estimation).""", argstr="--threads %d" )
	cost = traits.String( desc="""registration criterion""", argstr="--cost %s" )
	optimizer = traits.String( desc="""Optimizer used for minimization""", argstr="--optimizer %s" )
	transForm = traits.String( desc="""transformation type""", argstr="--transForm %s" )
	mg_levels = traits.Int( desc="""multi-resolution levels""", argstr="--mg-levels %d" )
	reference = traits.Int( desc="""Global reference all image should be aligned to. If set to a non-negative value, the images will be aligned to this references, and the cropped output image date will be injected into the original images. Leave at -1 if you don't care. In this case all images with be registered to a mean position of the movement""", argstr="--reference %d" )
	passes = traits.Int( desc="""registration passes""", argstr="--passes %d" )
	out_file = File(desc="output perfusion data set", argstr="--out-file %s" , mandatory = True )

#
# Output specification
#
class mia_2dmyomilles_OutputSpec(TraitedSpec):
	out_file = File(desc="output perfusion data set", exists = True )


#
# Task class specification
#
class mia_2dmyomilles(CommandLine):
	input_spec = mia_2dmyomilles_InputSpec
	output_spec = mia_2dmyomilles_OutputSpec
	_cmd = "mia-2dmyomilles"

	def _list_outputs(self):
		outputs = self.output_spec().get()
		outputs['out_file']=os.path.abspath(self.inputs.out_file)
		return outputs

#
# Main function used for testing
#
if __name__ == "__main__":
	mia_prog = mia_2dmyomilles()
	print( mia_prog.cmdline)
