# This file was generated by running 'miaxml2nipype.py /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/doc/mia-3ddistance-stats.xml /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_3ddistance_stats.py'
# '/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_3ddistance_stats.py' can be created by running 'mia-3ddistance-stats --help-xml >/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_3ddistance_stats.py'

from nipype.interfaces.base import (
        TraitedSpec,
        CommandLineInputSpec,
        CommandLine,
        File,
        traits
    )
import os
#
# Input specification
#
class mia_3ddistance_stats_InputSpec(CommandLineInputSpec):
	in_labels = traits.File( desc="""input label image""", argstr="--in-labels %s", exists=True , mandatory = True )
	ref_labels = traits.File( desc="""reference label image""", argstr="--ref-labels %s", exists=True , mandatory = True )
	label_map = traits.File( desc="""optional mapping of label numbers""", argstr="--label-map %s", exists=True )
	verbose = traits.Enum("info", "trace", "fail", "warning", "error", "debug", "message", "fatal",  desc="""verbosity of output, print messages of given level and higher priorities. Supported priorities starting at lowest level are:""", argstr="--verbose %s" )
	threads = traits.Int( desc="""Maxiumum number of threads to use for processing,This number should be lower or equal to the number of logical processor cores in the machine. (-1: automatic estimation).""", argstr="--threads %d" )
	out_file = File(desc="output file name to write the distances to. The output file is a csv file, containing distances listed for each label.", argstr="--out-file %s" , mandatory = True )

#
# Output specification
#
class mia_3ddistance_stats_OutputSpec(TraitedSpec):
	out_file = File(desc="output file name to write the distances to. The output file is a csv file, containing distances listed for each label.", exists = True )


#
# Task class specification
#
class mia_3ddistance_stats(CommandLine):
	input_spec = mia_3ddistance_stats_InputSpec
	output_spec = mia_3ddistance_stats_OutputSpec
	_cmd = "mia-3ddistance-stats"

	def _list_outputs(self):
		outputs = self.output_spec().get()
		outputs['out_file']=os.path.abspath(self.inputs.out_file)
		return outputs

#
# Main function used for testing
#
if __name__ == "__main__":
	mia_prog = mia_3ddistance_stats()
	print( mia_prog.cmdline)
