# This file was generated by running 'miaxml2nipype.py /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/doc/mia-3dfield2norm.xml /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_3dfield2norm.py'
# '/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_3dfield2norm.py' can be created by running 'mia-3dfield2norm --help-xml >/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_3dfield2norm.py'

from nipype.interfaces.base import (
        TraitedSpec,
        CommandLineInputSpec,
        CommandLine,
        File,
        traits
    )
import os
#
# Input specification
#
class mia_3dfield2norm_InputSpec(CommandLineInputSpec):
	in_vectorfield = traits.File( desc="""input vector field""", argstr="--in-vectorfield %s", exists=True , mandatory = True )
	verbose = traits.Enum("info", "trace", "fail", "warning", "error", "debug", "message", "fatal",  desc="""verbosity of output, print messages of given level and higher priorities. Supported priorities starting at lowest level are:""", argstr="--verbose %s" )
	threads = traits.Int( desc="""Maxiumum number of threads to use for processing,This number should be lower or equal to the number of logical processor cores in the machine. (-1: automatic estimation).""", argstr="--threads %d" )
	out_image = File(desc="output image comprising the per voxel norm of each image", argstr="--out-image %s" , mandatory = True )

#
# Output specification
#
class mia_3dfield2norm_OutputSpec(TraitedSpec):
	out_image = File(desc="output image comprising the per voxel norm of each image", exists = True )


#
# Task class specification
#
class mia_3dfield2norm(CommandLine):
	input_spec = mia_3dfield2norm_InputSpec
	output_spec = mia_3dfield2norm_OutputSpec
	_cmd = "mia-3dfield2norm"

	def _list_outputs(self):
		outputs = self.output_spec().get()
		outputs['out_image']=os.path.abspath(self.inputs.out_image)
		return outputs

#
# Main function used for testing
#
if __name__ == "__main__":
	mia_prog = mia_3dfield2norm()
	print( mia_prog.cmdline)
