# This file was generated by running 'miaxml2nipype.py /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/doc/mia-3disosurface-from-stack.xml /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/isosurface/mia_3disosurface_from_stack.py'
# '/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/isosurface/mia_3disosurface_from_stack.py' can be created by running 'mia-3disosurface-from-stack --help-xml >/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/isosurface/mia_3disosurface_from_stack.py'

from nipype.interfaces.base import (
        TraitedSpec,
        CommandLineInputSpec,
        CommandLine,
        File,
        traits
    )
import os
#
# Input specification
#
class mia_3disosurface_from_stack_InputSpec(CommandLineInputSpec):
	in_image = traits.File( desc="""input image filename pattern""", argstr="--in-image %s", exists=True , mandatory = True )
	verbose = traits.Enum("info", "trace", "fail", "warning", "error", "debug", "message", "fatal",  desc="""verbosity of output, print messages of given level and higher priorities. Supported priorities starting at lowest level are:""", argstr="--verbose %s" )
	iso_value = traits.Float( desc="""iso-value of iso surface to be extracted""", argstr="--iso-value %f" )
	max_faces = traits.Int( desc="""maximum number of Faces,""", argstr="--max-faces %d" )
	max_edges = traits.Int( desc="""maximum number of Edges""", argstr="--max-edges %d" )
	max_cost = traits.Float( desc="""maximum cost for edge collaps""", argstr="--max-cost %f" )
	ratio = traits.Float( desc="""ratio of faces(edges) to target number, at which  the optimization changes from edge-length to volume-optimized""", argstr="--ratio %f" )
	reverse_winding = traits.Bool( desc="""reverse the winding of the triangles in order to make normals point away from the high intensity area""", argstr="--reverse-winding" )
	threads = traits.Int( desc="""Maxiumum number of threads to use for processing,This number should be lower or equal to the number of logical processor cores in the machine. (-1: automatic estimation).""", argstr="--threads %d" )
	out_mesh = File(desc="output mesh", argstr="--out-mesh %s" , mandatory = True )

#
# Output specification
#
class mia_3disosurface_from_stack_OutputSpec(TraitedSpec):
	out_mesh = File(desc="output mesh", exists = True )


#
# Task class specification
#
class mia_3disosurface_from_stack(CommandLine):
	input_spec = mia_3disosurface_from_stack_InputSpec
	output_spec = mia_3disosurface_from_stack_OutputSpec
	_cmd = "mia-3disosurface-from-stack"

	def _list_outputs(self):
		outputs = self.output_spec().get()
		outputs['out_mesh']=os.path.abspath(self.inputs.out_mesh)
		return outputs

#
# Main function used for testing
#
if __name__ == "__main__":
	mia_prog = mia_3disosurface_from_stack()
	print( mia_prog.cmdline)
