# This file was generated by running 'miaxml2nipype.py /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/doc/mia-3dmany2one-nonrigid.xml /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_3dmany2one_nonrigid.py'
# '/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_3dmany2one_nonrigid.py' can be created by running 'mia-3dmany2one-nonrigid --help-xml >/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_3dmany2one_nonrigid.py'

from nipype.interfaces.base import (
        TraitedSpec,
        CommandLineInputSpec,
        CommandLine,
        File,
        traits
    )
import os
#
# Input specification
#
class mia_3dmany2one_nonrigid_InputSpec(CommandLineInputSpec):
	in_file = traits.File( desc="""input perfusion data set""", argstr="--in-file %s", exists=True , mandatory = True )
	optimizer = traits.String( desc="""Optimizer used for minimization""", argstr="--optimizer %s" )
	mg_levels = traits.Int( desc="""multi-resolution levels""", argstr="--mg-levels %d" )
	transForm = traits.String( desc="""transformation type""", argstr="--transForm %s" )
	ref = traits.Int( desc="""reference frame (-1 == use image in the middle)""", argstr="--ref %d" )
	verbose = traits.Enum("info", "trace", "fail", "warning", "error", "debug", "message", "fatal",  desc="""verbosity of output, print messages of given level and higher priorities. Supported priorities starting at lowest level are:""", argstr="--verbose %s" )
	threads = traits.Int( desc="""Maxiumum number of threads to use for processing,This number should be lower or equal to the number of logical processor cores in the machine. (-1: automatic estimation).""", argstr="--threads %d" )
	out_file = File(desc="file name for registered files", argstr="--out-file %s" )
	free_params = traits.ListStr(desc="Plug-in specifications of type 3dimage/fullcost", argstr="%s")
#
# Output specification
#
class mia_3dmany2one_nonrigid_OutputSpec(TraitedSpec):
	out_file = File(desc="file name for registered files")


#
# Task class specification
#
class mia_3dmany2one_nonrigid(CommandLine):
	input_spec = mia_3dmany2one_nonrigid_InputSpec
	output_spec = mia_3dmany2one_nonrigid_OutputSpec
	_cmd = "mia-3dmany2one-nonrigid"

	def _list_outputs(self):
		outputs = self.output_spec().get()
		outputs['out_file']=os.path.abspath(self.inputs.out_file)
		return outputs

#
# Main function used for testing
#
if __name__ == "__main__":
	mia_prog = mia_3dmany2one_nonrigid()
	print( mia_prog.cmdline)
