# This file was generated by running 'miaxml2nipype.py /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/doc/mia-3dmotioncompica-nonrigid.xml /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_3dmotioncompica_nonrigid.py'
# '/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_3dmotioncompica_nonrigid.py' can be created by running 'mia-3dmotioncompica-nonrigid --help-xml >/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_3dmotioncompica_nonrigid.py'

from nipype.interfaces.base import (
        TraitedSpec,
        CommandLineInputSpec,
        CommandLine,
        File,
        traits
    )
import os
#
# Input specification
#
class mia_3dmotioncompica_nonrigid_InputSpec(CommandLineInputSpec):
	in_file = traits.File( desc="""input images of consecutively numbered filed (nameXXXX.ext)""", argstr="--in-file %s", exists=True , mandatory = True )
	save_refs = traits.String( desc="""save reference images, the given string is used as file name base, the number pattern follows the input images, and the output format is always 'vista'""", argstr="--save-refs %s" )
	save_regs = traits.String( desc="""save intermediate registered images, the given string is used as file name base, the number pattern follows the input images, and the output format is always 'vista'""", argstr="--save-regs %s" )
	save_coeffs = traits.String( desc="""save mixing matrix to a text file""", argstr="--save-coeffs %s" )
	save_features = traits.String( desc="""save feature images as PNG""", argstr="--save-features %s" )
	verbose = traits.Enum("info", "trace", "fail", "warning", "error", "debug", "message", "fatal",  desc="""verbosity of output, print messages of given level and higher priorities. Supported priorities starting at lowest level are:""", argstr="--verbose %s" )
	fastica = traits.String( desc="""FastICA implementationto be used""", argstr="--fastica %s" )
	components = traits.Int( desc="""ICA components 0 = automatic estimation""", argstr="--components %d" )
	no_normalize = traits.Bool( desc="""don't normalized ICs""", argstr="--no-normalize" )
	no_meanstrip = traits.Bool( desc="""don't strip the mean from the mixing curves""", argstr="--no-meanstrip" )
	skip = traits.Int( desc="""skip images at the beginning of the series e.g. because as they are of other modalities""", argstr="--skip %d" )
	max_ica_iter = traits.Int( desc="""maximum number of iterations in ICA""", argstr="--max-ica-iter %d" )
	threads = traits.Int( desc="""Maxiumum number of threads to use for processing,This number should be lower or equal to the number of logical processor cores in the machine. (-1: automatic estimation).""", argstr="--threads %d" )
	optimizer = traits.String( desc="""Optimizer used for minimization""", argstr="--optimizer %s" )
	start_c_rate = traits.Float( desc="""start coefficinet rate in spines, gets divided by --c-rate-divider with every pass""", argstr="--start-c-rate %f" )
	c_rate_divider = traits.Float( desc="""cofficient rate divider for each pass""", argstr="--c-rate-divider %f" )
	start_divcurl = traits.Float( desc="""start divcurl weight, gets divided by --divcurl-divider with every pass""", argstr="--start-divcurl %f" )
	divcurl_divider = traits.Float( desc="""divcurl weight scaling with each new pass""", argstr="--divcurl-divider %f" )
	imagecost = traits.String( desc="""image cost""", argstr="--imagecost %s" )
	mg_levels = traits.Int( desc="""multi-resolution levels""", argstr="--mg-levels %d" )
	passes = traits.Int( desc="""registration passes""", argstr="--passes %d" )
	out_file = File(desc="output image name (as C format string including a %04d in order to define the file numbering)", argstr="--out-file %s" , mandatory = True )

#
# Output specification
#
class mia_3dmotioncompica_nonrigid_OutputSpec(TraitedSpec):
	out_file = File(desc="output image name (as C format string including a %04d in order to define the file numbering)", exists = True )


#
# Task class specification
#
class mia_3dmotioncompica_nonrigid(CommandLine):
	input_spec = mia_3dmotioncompica_nonrigid_InputSpec
	output_spec = mia_3dmotioncompica_nonrigid_OutputSpec
	_cmd = "mia-3dmotioncompica-nonrigid"

	def _list_outputs(self):
		outputs = self.output_spec().get()
		outputs['out_file']=os.path.abspath(self.inputs.out_file)
		return outputs

#
# Main function used for testing
#
if __name__ == "__main__":
	mia_prog = mia_3dmotioncompica_nonrigid()
	print( mia_prog.cmdline)
