# This file was generated by running 'miaxml2nipype.py /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/doc/mia-3dnonrigidreg.xml /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_3dnonrigidreg.py'
# '/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_3dnonrigidreg.py' can be created by running 'mia-3dnonrigidreg --help-xml >/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_3dnonrigidreg.py'

from nipype.interfaces.base import (
        TraitedSpec,
        CommandLineInputSpec,
        CommandLine,
        File,
        traits
    )
import os
#
# Input specification
#
class mia_3dnonrigidreg_InputSpec(CommandLineInputSpec):
	in_image = traits.File( desc="""test image""", argstr="--in-image %s", exists=True , mandatory = True )
	ref_image = traits.File( desc="""reference image""", argstr="--ref-image %s", exists=True , mandatory = True )
	verbose = traits.Enum("info", "trace", "fail", "warning", "error", "debug", "message", "fatal",  desc="""verbosity of output, print messages of given level and higher priorities. Supported priorities starting at lowest level are:""", argstr="--verbose %s" )
	threads = traits.Int( desc="""Maxiumum number of threads to use for processing,This number should be lower or equal to the number of logical processor cores in the machine. (-1: automatic estimation).""", argstr="--threads %d" )
	levels = traits.Int( desc="""multi-resolution levels""", argstr="--levels %d" )
	optimizer = traits.String( desc="""Optimizer used for minimization""", argstr="--optimizer %s" )
	transForm = traits.String( desc="""transformation type""", argstr="--transForm %s" )
	out_image = File(desc="registered output image", argstr="--out-image %s" , mandatory = True )
	transformation = File(desc="output transformation", argstr="--transformation %s" )
	free_params = traits.ListStr(desc="Plug-in specifications of type 3dimage/fullcost", argstr="%s")
#
# Output specification
#
class mia_3dnonrigidreg_OutputSpec(TraitedSpec):
	out_image = File(desc="registered output image", exists = True )
	transformation = File(desc="output transformation")


#
# Task class specification
#
class mia_3dnonrigidreg(CommandLine):
	input_spec = mia_3dnonrigidreg_InputSpec
	output_spec = mia_3dnonrigidreg_OutputSpec
	_cmd = "mia-3dnonrigidreg"

	def _list_outputs(self):
		outputs = self.output_spec().get()
		outputs['out_image']=os.path.abspath(self.inputs.out_image)
		outputs['transformation']=os.path.abspath(self.inputs.transformation)
		return outputs

#
# Main function used for testing
#
if __name__ == "__main__":
	mia_prog = mia_3dnonrigidreg()
	print( mia_prog.cmdline)
