# This file was generated by running 'miaxml2nipype.py /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/doc/mia-3dvfcompare.xml /build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_3dvfcompare.py'
# '/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_3dvfcompare.py' can be created by running 'mia-3dvfcompare --help-xml >/build/mia-PDyCdm/mia-2.4.6/obj-mips64el-linux-gnuabi64/src/mia_3dvfcompare.py'

from nipype.interfaces.base import (
        TraitedSpec,
        CommandLineInputSpec,
        CommandLine,
        File,
        traits
    )
import os
#
# Input specification
#
class mia_3dvfcompare_InputSpec(CommandLineInputSpec):
	in_file_1 = traits.File( desc="""input vector field 1""", argstr="--in-file-1 %s", exists=True , mandatory = True )
	in_file_2 = traits.File( desc="""input vector field 2""", argstr="--in-file-2 %s", exists=True , mandatory = True )
	delta = traits.Float( desc="""Maximum difference between vector to be ignored""", argstr="--delta %f" )
	verbose = traits.Enum("info", "trace", "fail", "warning", "error", "debug", "message", "fatal",  desc="""verbosity of output, print messages of given level and higher priorities. Supported priorities starting at lowest level are:""", argstr="--verbose %s" )
	threads = traits.Int( desc="""Maxiumum number of threads to use for processing,This number should be lower or equal to the number of logical processor cores in the machine. (-1: automatic estimation).""", argstr="--threads %d" )

#
# Output specification
#
class mia_3dvfcompare_OutputSpec(TraitedSpec):
	stdout = traits.Str('result from stdout')


#
# Task class specification
#
class mia_3dvfcompare(CommandLine):
	input_spec = mia_3dvfcompare_InputSpec
	output_spec = mia_3dvfcompare_OutputSpec
	_cmd = "mia-3dvfcompare"

	def _list_outputs(self):
		outputs = self.output_spec().get()
		return outputs
	def aggregate_outputs(self, runtime=None, needed_outputs=None):
		outputs = super(mia_3dvfcompare, self).aggregate_outputs(runtime, needed_outputs)
		outputs.stdout = runtime.stdout
		return outputs

#
# Main function used for testing
#
if __name__ == "__main__":
	mia_prog = mia_3dvfcompare()
	print( mia_prog.cmdline)
